Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::sffloat Class Reference

A single precision floating point node field value. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::sffloat:
[legend]

List of all members.

## Public Types

typedef float | value_type
| Type of value.

## Public Member Functions

| sffloat (float value=0.0) throw ()
| Construct.
| sffloat (const sffloat &sff)
| Construct a copy.
virtual | ~sffloat () throw ()
| Destroy.
sffloat & | operator= (const sffloat &sff) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (sffloat &sff) throw ()
| Swap.

## Static Public Attributes

static const type_id | field_value_type_id = sffloat_id
| `field_value::type_id` for this class.

## Private Member Functions

virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual sffloat & | do_assign (const field_value &value) throw ( std::bad_cast )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the field_value::type_id associated with this class.
virtual void | print (std::ostream &out) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const sffloat &lhs, const sffloat &rhs) throw()
| Compare for equality.
bool | operator!= (const sffloat &lhs, const sffloat &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::sffloat &a, openvrml::sffloat &b)
| Swap the values of `a` and `b`.

## Detailed Description

A single precision floating point node field value.

Model of
  Field Value

## Member Typedef Documentation

openvrml::sffloat::value_type

Type of value.

## Constructor & Destructor Documentation

openvrml::sffloat::sffloat | ( | float | value = `0.0` | ) | throw ()`[explicit]`

Construct.

Parameters:

  `[in]` | value | initial value

openvrml::sffloat::sffloat | ( | const sffloat & | sff | ) |

Construct a copy.

Parameters:

  `[in]` | sff | the instance to copy.

openvrml::sffloat::~sffloat | ( |  | ) | throw ()`[virtual]`

Destroy.

## Member Function Documentation

openvrml::sffloat & openvrml::sffloat::operator= | ( | const sffloat & | sff | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  `[in]` | sff | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

const openvrml::sffloat::value_type & openvrml::sffloat::value | ( |  | ) | const throw ()

Access.

Returns:
  the floating point value.

Reimplemented from openvrml::field_value.

void openvrml::sffloat::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  `[in]` | val | the new value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

void openvrml::sffloat::swap | ( | sffloat & | sff | ) | throw ()

Swap.

Parameters:

  `[in,out]` | sff | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::sffloat::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::sffloat & openvrml::sffloat::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast )`[private, virtual]`

Virtual assignment.

Parameters:

  `[in]` | value | the new value to give the object.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an sffloat.

openvrml::field_value::type_id openvrml::sffloat::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the field_value::type_id associated with this class.

Returns:
  `field_value::sffloat`.

Implements openvrml::field_value.

void openvrml::sffloat::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  `[in,out]` | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const sffloat & | lhs,
|  | const sffloat & | rhs |
| ) |  |  | throw()`[related]`

Compare for equality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const sffloat & | lhs,
|  | const sffloat & | rhs |
| ) |  |  | throw()`[related]`

Compare for inequality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::sffloat & | a,
|  | openvrml::sffloat & | b |
| ) |  |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  `[in,out]` | a |
  `[in,out]` | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::sffloat::field_value_type_id = sffloat_id`[static]`

`field_value::type_id` for this class.